package io.gitlab.jfronny.translater;

import io.gitlab.jfronny.libjf.translate.api.TranslateService;
import io.gitlab.jfronny.translater.transformer.CachingTransformer;
import io.gitlab.jfronny.translater.transformer.TransformingMap;
import io.gitlab.jfronny.translater.transformer.TranslatingTransformer;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Map;

@Environment(EnvType.CLIENT)
public class Translater {
    public static final String MOD_ID = "translater";
    public static final Logger LOGGER = LoggerFactory.getLogger(MOD_ID);
    private static final TransformingMap map = new TransformingMap(new CachingTransformer(new TranslatingTransformer<>(TranslateService.getConfigured())));

    public static boolean progressUIEnabled() {
        return Cfg.renderProgress == ProgressMode.Full || Cfg.renderProgress == ProgressMode.Gui;
    }
    public static boolean progressLogsEnabled() {
        return Cfg.renderProgress == ProgressMode.Full || Cfg.renderProgress == ProgressMode.Console;
    }

    public static @NotNull TransformingMap getMap(@Nullable Map<String, String> base) {
        if (base != null) map.updateBacker(base);
        return map;
    }
}
