package io.gitlab.jfronny.translater.transformer;

import io.gitlab.jfronny.translater.Translater;
import io.gitlab.jfronny.translater.mixin.MinecraftClientAccessor;
import net.minecraft.client.MinecraftClient;

import java.util.Collection;
import java.util.Map;
import java.util.Set;

public class TransformingMap implements Map<String, String> {
    private final Transformer transformer;
    private Map<String, String> backer = null;
    public boolean initializing = false;
    private String initProgress = null;

    public TransformingMap(Transformer t) {
        transformer = t;
    }

    public void updateBacker(Map<String, String> backer) {
        if (this.backer != backer) {
            this.backer = backer;
            Collection<String> strings = backer.values();
            initializing = true;
            final int max = strings.size();
            int i = 0;
            for (String value : strings) {
                initProgress = "Transforming " + i++ + "/" + max;
                if (Translater.progressLogsEnabled())
                    Translater.LOGGER.info(initProgress);
                if (Translater.progressUIEnabled() && i % 10 == 0)
                    ((MinecraftClientAccessor) MinecraftClient.getInstance()).invokeRender(false);
                initProgress = null;
                transformer.transform(value);
            }
            initializing = false;
        }
    }

    public String getInitProgress() {
        if (initProgress == null || !initializing) throw new IllegalStateException("Tried to get init progress while not initializing");
        return initProgress;
    }

    @Override
    public int size() {
        return backer.size();
    }

    @Override
    public boolean isEmpty() {
        return backer.isEmpty();
    }

    @Override
    public boolean containsKey(Object o) {
        return backer.containsKey(o);
    }

    @Override
    public boolean containsValue(Object o) {
        return backer.containsValue(o);
    }

    @Override
    public String get(Object o) {
        if (o instanceof String && ((String)o).startsWith("translater."))
            return backer.get(o);
        return transformer.transform(backer.get(o));
    }

    @Override
    public String put(String s, String s2) {
        transformer.transform(s2);
        return backer.put(s, s2);
    }

    @Override
    public String remove(Object o) {
        return backer.remove(o);
    }

    @Override
    public void putAll(Map<? extends String, ? extends String> map) {
        for (String value : map.values()) {
            transformer.transform(value);
        }
        backer.putAll(map);
    }

    @Override
    public void clear() {
        backer.clear();
    }

    @Override
    public Set<String> keySet() {
        return backer.keySet();
    }

    @Override
    public Collection<String> values() {
        return backer.values();
    }

    @Override
    public Set<Entry<String, String>> entrySet() {
        return backer.entrySet();
    }
}
